package org.openxma.dsl.reference.dao.impl;

import org.hibernate.HibernateException;
import org.hibernate.event.FlushEntityEvent;
import org.hibernate.event.FlushEntityEventListener;
import org.hibernate.event.PostInsertEvent;
import org.hibernate.event.PostInsertEventListener;
import org.hibernate.event.PostUpdateEvent;
import org.hibernate.event.PostUpdateEventListener;
import org.hibernate.event.PreInsertEvent;
import org.hibernate.event.PreInsertEventListener;
import org.hibernate.event.PreUpdateEvent;
import org.hibernate.event.PreUpdateEventListener;
import org.hibernate.event.SaveOrUpdateEvent;
import org.hibernate.event.SaveOrUpdateEventListener;

public class EventListener implements FlushEntityEventListener, PreUpdateEventListener, PostUpdateEventListener,
        SaveOrUpdateEventListener, PreInsertEventListener, PostInsertEventListener {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    private int saveOrUpdateCounter;
    private int postUpdateCounter;
    private int preUpdateCounter;
    private int flushCounter;
    private int postInsertCounter;
    private int preInsertCounter;

    public void reset() {
        saveOrUpdateCounter=0;
        postUpdateCounter=0;
        preUpdateCounter=0;
        flushCounter=0;
        postInsertCounter=0;
        preInsertCounter=0;
    }

    public void onFlushEntity(FlushEntityEvent arg0) throws HibernateException {
        flushCounter++;
    }

    public boolean onPreUpdate(PreUpdateEvent arg0) {
        preUpdateCounter++;
        return false;
    }

    public void onPostUpdate(PostUpdateEvent arg0) {
        postUpdateCounter++;
    }

    public void onSaveOrUpdate(SaveOrUpdateEvent arg0) throws HibernateException {
        saveOrUpdateCounter++;
    }

    public boolean onPreInsert(PreInsertEvent arg0) {
        preInsertCounter++;
        return false;
    }

    public void onPostInsert(PostInsertEvent arg0) {
        postInsertCounter++;

    }

    public int getSaveOrUpdateCounter() {
        return saveOrUpdateCounter;
    }

    public int getPostUpdateCounter() {
        return postUpdateCounter;
    }

    public int getPreUpdateCounter() {
        return preUpdateCounter;
    }

    public int getFlushCounter() {
        return flushCounter;
    }

    public int getPostInsertCounter() {
        return postInsertCounter;
    }

    public int getPreInsertCounter() {
        return preInsertCounter;
    }

}
